;==========================================================
;resistencias 1.0.		victor-manuel@ctv.es
;por Vctor Manuel Ropero Martn, 28 de Abril de 2000
;calcula el valor de una resistencia por el cdigo de colores
;ensamblado con Assembly Studio 86 v. 3.1
;==========================================================

#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Resistencias",0

ProgStart:
	call _runindicoff
	ld hl,pantalla_principal
	call copia_pic

Tecla:
	call _getkey
	cp kExit
	jr z,Salir
	cp kF1
	jr z,menu_Banda1
	cp kF2
	jr z,menu_Banda2
	cp kF3
	jr z,menu_Banda3
	cp kF4
	jr z,menu_Banda4
	cp kF5
	jr z,Salir
	jp Tecla		;si no se pulsa ninguna de las teclas
Salir:
	call _clrLCD
	call _clrScrn
	ret
menu_Banda1:
	call pone_selec_color
	ld a,(color_sel)
	ld (banda1),a
	jp pone_valor_res
menu_Banda2:
	call pone_selec_color
	ld a,(color_sel)
	ld (banda2),a
	jp pone_valor_res
menu_Banda3:
	call pone_selec_color
	ld a,(color_sel)
	ld (banda3),a
	jp pone_valor_res
menu_Banda4:
	call pone_selec_color
	ld a,(color_sel)
	ld (banda4),a
	jp pone_valor_res
pone_valor_res:
	call _clrLCD
	ld hl,pantalla_principal
	call copia_pic
	ld a,2
	ld (_curRow),a
	ld a,6
	ld (_curCol),a
	ld a,(banda4)			;comprobamos cuntas bandas hay
	ld b,$0C
	cp b
	jr z,pone_tres_bandas		;slo hay 3 bandas
pone_cuatro_bandas:
	ld a,(banda1)
	add a,48
	call _putc
	ld a,(banda2)
	add a,48
	call _putc
	ld a,(banda3)
	add a,48
	call _putc
	ld a,(banda4)			;calculamos el multiplicador
	jp fin_pone_valor_res
pone_tres_bandas:
	ld a,(banda1)
	add a,48
	call _putc
	ld a,(banda2)
	add a,48
	call _putc
	ld a,(banda3)			;calculamos el multiplicador
fin_pone_valor_res:
	ld b,a
	call pone_mul			;y ponemos el texto correspondiente
	call pone_colores
	jp Tecla				;vuelta al inicio


;==========================================================
;busca multiplicador a partir del valor b
;y lo ponemos en la pantalla donde est el cursor
;==========================================================
pone_mul:
	ld hl,multiplicador-6
	inc b
otro_mul:
	dec b
	inc hl				;se resta el nmero de bytes
	inc hl				;de las cadenas de multiplicador
	inc hl
	inc hl
	inc hl
	inc hl
	jr nz,otro_mul
	call _puts
	ret
;==========================================================


;==========================================================
;pone_colores: pone por pantalla el color de cada banda
;==========================================================
pone_colores:
	ld a,56
	ld (_penRow),a
	ld a,8
	ld (_penCol),a
	ld a,(banda1)
	call pone_un_color		;ponemos banda1
	ld a,33
	ld (_penCol),a
	ld a,(banda2)
	call pone_un_color		;ponemos banda2
	ld a,58
	ld (_penCol),a
	ld a,(banda3)
	call pone_un_color		;ponemos banda3
	ld a,83
	ld (_penCol),a
	ld a,(banda4)
	call pone_un_color		;ponemos banda4
	ret						;volvemos
pone_un_color:
	add a,0					;si es cero no hacemos operaciones
	jr z,menu_color_cero
	ld h,a
	ld l,9
	call _HtimesL
	push hl
	pop bc
	ld hl,colores
	add hl,bc
	jp fin_pone_colores
menu_color_cero:
	ld hl,colores
fin_pone_colores:
	ld b,3		
	call _vputsn			;sacamos slo 3 letras
	ret
;==========================================================



;==========================================================
;sacamos los colores por pantalla y permitimos su seleccin
;guardamos la seleccin en color_sel
;==========================================================
pone_selec_color:
	xor a
	ld (color_sel),a		;iniciamos color=0
	jp pone_selec_color_otro
pone_selec_color_tecla:
	call _getkey
	cp kDown
	jr z,uno_menos
	cp kUp
	jr z,uno_mas
	cp kLeft
	jr z,uno_menos
	cp kRight
	jr z,uno_mas
	cp kEnter
	jr z,pone_selec_color_fin
	jp pone_selec_color_tecla
uno_menos:					;Carga un color menos
	ld a,(color_sel)		;comprobamos el color actual
	ld b,0					;valor del color mnimo
	cp b
	jr z,pone_selec_color_otro		
	dec a	
	jp pone_selec_color_otro
uno_mas:					;carga un color ms
	ld a,(color_sel)		;comprobamos el color actual
	ld b,12					;valor del color mximo
	cp b
	jr z,pone_selec_color_otro		
	inc a				
pone_selec_color_otro:			;pone en pantalla otro color
	ld (color_sel),a
	call _clrLCD
	ld a,3
	ld (_curRow),a
	ld a,5
	ld (_curCol),a
	ld a,207				;flecha izqd.
	call _putc
	ld a,16
	ld (_curCol),a
	ld a,5					;flecha dcha.
	call _putc
	ld a,7
	ld (_curCol),a
	ld a,(color_sel)
	and a					;si es cero no hacemos operaciones
	jr z,color_cero
	ld h,a
	ld l,9
	call _HtimesL
	push hl
	pop bc
	ld hl,colores
	add hl,bc
	call _puts
	jp pone_selec_color_tecla
color_cero:
	ld hl,colores
	call _puts
	jp pone_selec_color_tecla
pone_selec_color_fin:
	ret
;=========================================================


;====================================================
;copia_pic
;hl -> puntero al inico del dibujo
;====================================================
copia_pic:
	ld de,$FC00           	; puntero a inicio de memoria de pantalla
	ld bc,$0400				; se carga 1024 en el contador bc
	ldir					; se copian los 1024 bytes
	ret
;====================================================


;==========================================================
;datos y variables
;==========================================================
banda1:
	.db $00
banda2:
	.db $00
banda3:
	.db $00
banda4:
	.db $0C
valor_mul:
	.db "000",0
multiplicador:		;valores de multiplicador (6bytes/color)
					;$CA=omega,$20=" ",$30="0",$47="G",$4B="K",$4D="M",$6D="m"
	.db $20,$CA,$20,$20,$20,0		;negro	
	.db $30,$20,$CA,$20,$20,0		;marrn
	.db $30,$30,$20,$CA,$20,0		;rojo
	.db $20,$4B,$CA,$20,$20,0		;naranja
	.db $30,$20,$4B,$CA,$20,0		;amarillo
	.db $30,$30,$20,$4B,$CA,0		;verde
	.db $20,$4D,$CA,$20,$20,0		;azul
	.db $30,$20,$4D,$CA,$20,0		;violeta
	.db $30,$30,$20,$4D,$CA,0		;gris
	.db $20,$47,$CA,$20,$20,0		;blanco
	.db $30,$30,$20,$6D,$CA,0		;oro
	.db $30,$20,$6D,$CA,$20,0		;plata
colores:		;tienen que tener 8+1 bytes por color
	.db "NEGRO   ",0
	.db "MARRON  ",0
	.db "ROJO    ",0
	.db "NARANJA ",0
	.db "AMARILLO",0
	.db "VERDE   ",0
	.db "AZUL    ",0
	.db "VIOLETA ",0
	.db "GRIS    ",0
	.db "BLANCO  ",0
	.db "ORO     ",0
	.db "PLATA   ",0
	.db "NINGUNO ",0
color_sel:			;color seleccionado
	.db $00
pantalla_principal:
; Created with BMP2ASM
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111111,%11100110,%11001101,%10011101,%11110011,%00011111,%00110011,%01111011,%00110001,%10011111,%11111111,%11101110,%00111111,%11111111
  .db %11111111,%11111111,%11111111,%11011101,%01010101,%01111010,%11110101,%01111110,%11101101,%01110101,%01010111,%01111111,%11110101,%11001110,%10111111,%11111111
  .db %11111111,%11111111,%11111111,%11011101,%01010101,%01001010,%11110101,%00111110,%11101101,%01110101,%00110011,%10111111,%11110101,%11101110,%10111111,%11111111
  .db %11111111,%11111111,%11111111,%11011101,%01010101,%01101010,%11110101,%01111110,%11101101,%01110101,%01010111,%11011111,%11110101,%11101110,%10111111,%11111111
  .db %11111111,%11111111,%11111111,%11100110,%11001101,%10011101,%11110011,%00011111,%00110011,%00011011,%01010001,%00111111,%11111011,%01101010,%00111111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111001,%11111111,%11101010,%11110111,%11111111,%10111011,%11100111,%11111111,%11111111,%11111101,%11011111,%11110110,%11111111,%11111111
  .db %11111111,%11111111,%11111010,%11011010,%11101011,%11010011,%01101011,%10010011,%11101011,%01100111,%01110101,%10111100,%10011001,%01010011,%10011111,%11111111
  .db %11111111,%11111111,%11111001,%10101001,%11101010,%10110110,%10100111,%10101011,%11100110,%10101010,%10110011,%01011101,%01010101,%00110110,%10101111,%11111111
  .db %11111111,%11111111,%11111011,%10101011,%11101010,%10110110,%10101111,%10111011,%11101010,%10100110,%01110111,%01011101,%11010101,%01110110,%10101111,%11111111
  .db %11111111,%11111111,%11111011,%11011011,%11110110,%11011011,%01101111,%10111010,%11101011,%01101111,%00110111,%10111101,%11011001,%01111010,%10101111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000011,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00001111,%11111110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11111111,%11100000,%00000000,%00000000
  .db %00000000,%00000000,%00011111,%11111110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11111111,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%00111000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00111000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000011,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11001111,%11111111,%01111110,%11100111,%11111111,%10111110,%01110011,%11111111,%11011111,%00111001,%11111111,%11101111,%10101111,%11111111,%11111111,%11111111
  .db %11010110,%01001110,%01100100,%11101011,%00100111,%00110011,%10110101,%10010011,%10011001,%11011010,%11001001,%11001100,%10101111,%11111111,%11111111,%11111111
  .db %11001101,%01010101,%01010110,%11100110,%10101010,%10101011,%01110011,%01010101,%01010101,%10111001,%10101010,%10101010,%10001111,%11111111,%11111111,%11111111
  .db %11010101,%01010101,%01010110,%11101010,%10101010,%10101010,%11110101,%01010101,%01010101,%11011010,%10101010,%10101010,%11101111,%11110011,%11101011,%11111111
  .db %11001110,%01010110,%01100110,%11100111,%00101011,%00110010,%00110011,%10010101,%10011001,%00111001,%11001010,%11001100,%11101111,%11101111,%00101110,%10111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11110110,%10101010,%01111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111010,%10101010,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11100111,%00101010,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111

.end
