;==========================================================
;resistors 1.0, English Version
;by Vctor Manuel Ropero Martn, 28-April-2000. victor-manuel@ctv.es
;calculate the value of a resistor from the code of colors
;assembled with Assembly Studio 86 v. 3.1
;==========================================================

#include "ti86asm.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Resistors",0

ProgStart:
	call _runindicoff
	ld hl,main_screen
	call put_screen

main_menu:
	call _getkey
	cp kExit
	jr z,Salir
	cp kF1
	jr z,menu_line1
	cp kF2
	jr z,menu_line2
	cp kF3
	jr z,menu_line3
	cp kF4
	jr z,menu_line4
	cp kF5
	jr z,Salir
	jp main_menu
Salir:
	call _clrLCD
	call _clrScrn
	ret
menu_line1:					;get the value of line 1
	call put_colors
	ld a,(color_sel)
	ld (line1),a
	jp put_res_value
menu_line2:
	call put_colors
	ld a,(color_sel)
	ld (line2),a
	jp put_res_value
menu_line3:
	call put_colors
	ld a,(color_sel)
	ld (line3),a
	jp put_res_value
menu_line4:
	call put_colors
	ld a,(color_sel)
	ld (line4),a
	jp put_res_value
put_res_value:				;get the value of the resistor and put the text
	call _clrLCD
	ld hl,main_screen
	call put_screen
	ld a,2
	ld (_curRow),a
	ld a,6
	ld (_curCol),a
	ld a,(line4)			;Is there 4 lines?.
	ld b,$0C
	cp b
	jr z,put_three_lines		;only 3 lines
put_four_lines:
	ld a,(line1)
	add a,48
	call _putc
	ld a,(line2)
	add a,48
	call _putc
	ld a,(line3)
	add a,48
	call _putc
	ld a,(line4)			;the multiplicator is in the fourth line
	jp end_put_res_value
put_three_lines:
	ld a,(line1)
	add a,48
	call _putc
	ld a,(line2)
	add a,48
	call _putc
	ld a,(line3)			;the multiplicator is in the third line
end_put_res_value:
	ld b,a
	call put_mul			;put the multiplicators text
	call put_color_line
	jp main_menu				;return


;==========================================================
;gets the value of multiplicator from b
;and puts it in the cursor position
;==========================================================
put_mul:
	ld hl,multiplicator-6
	inc b
other_mul:
	dec b
	inc hl				
	inc hl				
	inc hl
	inc hl
	inc hl
	inc hl
	jr nz,other_mul
	call _puts
	ret
;==========================================================


;==========================================================
;print the colors of the each line in the screen
;==========================================================
put_color_line:
	ld a,56
	ld (_penRow),a
	ld a,8
	ld (_penCol),a
	ld a,(line1)
	call put_one_color_line		;puts line1
	ld a,33
	ld (_penCol),a
	ld a,(line2)
	call put_one_color_line		;puts line2
	ld a,58
	ld (_penCol),a
	ld a,(line3)
	call put_one_color_line		;puts line3
	ld a,83
	ld (_penCol),a
	ld a,(line4)
	call put_one_color_line		;pputss line4
	ret						;retunr
put_one_color_line:
	add a,0					;if its 0 dont do anything
	jr z,put_color_zero
	ld h,a
	ld l,9
	call _HtimesL
	push hl
	pop bc
	ld hl,colors
	add hl,bc
	jp end_put_color_line
put_color_zero:
	ld hl,colors
end_put_color_line:
	ld b,3		
	call _vputsn			;only prints 3 caracters
	ret
;==========================================================



;==========================================================
;select the color of the line
;store selected color in color_sel
;==========================================================
put_colors:
	xor a
	ld (color_sel),a		;first color=0
	jp put_colors_other
put_colors_key:
	call _getkey
	cp kDown
	jr z,put_colors_less
	cp kUp
	jr z,put_colors_more
	cp kLeft
	jr z,put_colors_less
	cp kRight
	jr z,put_colors_more
	cp kEnter
	jr z,put_colors_end
	jp put_colors_key
put_colors_less:					;Carga un color menos
	ld a,(color_sel)		;comprobamos el color actual
	ld b,0					;valor del color mnimo
	cp b
	jr z,put_colors_other		
	dec a	
	jp put_colors_other
put_colors_more:					;carga un color ms
	ld a,(color_sel)		;comprobamos el color actual
	ld b,12					;valor del color mximo
	cp b
	jr z,put_colors_other		
	inc a				
put_colors_other:			;pone en pantalla otro color
	ld (color_sel),a
	call _clrLCD
	ld a,3
	ld (_curRow),a
	ld a,5
	ld (_curCol),a
	ld a,207				;flecha izqd.
	call _putc
	ld a,16
	ld (_curCol),a
	ld a,5					;flecha dcha.
	call _putc
	ld a,7
	ld (_curCol),a
	ld a,(color_sel)
	and a					;si es cero no hacemos operaciones
	jr z,puts_colors_zero
	ld h,a
	ld l,9
	call _HtimesL
	push hl
	pop bc
	ld hl,colors
	add hl,bc
	call _puts
	jp put_colors_key
puts_colors_zero:
	ld hl,colors
	call _puts
	jp put_colors_key
put_colors_end:
	ret
;=========================================================


;====================================================
;put_screen
;hl -> pointer at the begining of the draw (1024 bytes)
;====================================================
put_screen:
	ld de,$FC00           	; puntero a inicio de memoria de pantalla
	ld bc,$0400				; se carga 1008 en el contador bc
	ldir					; se copian los 1008 bytes
	ret
;====================================================


;==========================================================
;data
;==========================================================
line1:
	.db $00
line2:
	.db $00
line3:
	.db $00
line4:
	.db $0C
mul_value:
	.db "000",0
multiplicator:		; multiplicator values(6bytes/color)
					;$CA=Omega,$20=" "$30="0",$47="G",$4B="K",$4D="M",=$6D="m"
	.db $20,$CA,$20,$20,$20,0		;black	
	.db $30,$20,$CA,$20,$20,0		;brown
	.db $30,$30,$20,$CA,$20,0		;red
	.db $20,$4B,$CA,$20,$20,0		;orange
	.db $30,$20,$4B,$CA,$20,0		;yellow
	.db $30,$30,$20,$4B,$CA,0		;green
	.db $20,$4D,$CA,$20,$20,0		;blue
	.db $30,$20,$4D,$CA,$20,0		;violet
	.db $30,$30,$20,$4D,$CA,0		;grey
	.db $20,$47,$CA,$20,$20,0		;white
	.db $30,$30,$20,$6D,$CA,0		;gold
	.db $30,$20,$6D,$CA,$20,0		;silver
colors:		;8+1 bytes/color
	.db "BLACK   ",0
	.db "BROWN   ",0
	.db "RED     ",0
	.db "ORANGE  ",0
	.db "YELLOW  ",0
	.db "GREEN   ",0
	.db "BLUE    ",0
	.db "VIOLET  ",0
	.db "GREY    ",0
	.db "WHITE   ",0
	.db "GOLD    ",0
	.db "SILVER  ",0
	.db "NOTHING ",0
color_sel:		;selected color
	.db $00
main_screen:
; Created with BMP2ASM
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11110111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111111,%11111110,%01100110,%11110110,%01101100,%11111001,%10110011,%00011111,%11111111,%11111111,%11111111,%11101110,%00111111,%11111111
  .db %11111111,%11111111,%11111111,%11111101,%11011010,%11101010,%10111011,%11110111,%01010101,%01111111,%11111111,%11111111,%11110101,%11001110,%10111111,%11111111
  .db %11111111,%11111111,%11111111,%11111101,%11011010,%11101010,%01111101,%11110111,%01010101,%00111111,%11111111,%11111111,%11110101,%11101110,%10111111,%11111111
  .db %11111111,%11111111,%11111111,%11111101,%11011010,%11101010,%10111110,%11110111,%01010101,%01111111,%11111111,%11111111,%11110101,%11101110,%10111111,%11111111
  .db %11111111,%11111111,%11111111,%11111110,%01100110,%00110110,%10111001,%11111001,%10110011,%00011111,%11111111,%11111111,%11111011,%01101010,%00111111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111001,%11111111,%11101010,%11110111,%11111111,%10111011,%11100111,%11111111,%11111111,%11111101,%11011111,%11110110,%11111111,%11111111
  .db %11111111,%11111111,%11111010,%10101111,%11101011,%11010011,%01101011,%10010011,%11101011,%01100111,%01110101,%10111100,%10011001,%01010011,%10011111,%11111111
  .db %11111111,%11111111,%11111001,%10101111,%11101010,%10110110,%10100111,%10101011,%11100110,%10101010,%10110011,%01011101,%01010101,%00110110,%10101111,%11111111
  .db %11111111,%11111111,%11111010,%11011111,%11101010,%10110110,%10101111,%10111011,%11101010,%10100110,%01110111,%01011101,%11010101,%01110110,%10101111,%11111111
  .db %11111111,%11111111,%11111001,%10111111,%11110110,%11011011,%01101111,%10111010,%11101011,%01101111,%00110111,%10111101,%11011001,%01111010,%10101111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000011,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00001111,%11111110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11111111,%11100000,%00000000,%00000000
  .db %00000000,%00000000,%00011111,%11111110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11111111,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%00111000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00111000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000110,%00000011,%00001100,%00110000,%11000000,%00000000,%00000000,%00000000,%01100000,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000011,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%10000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
  .db %11111011,%10111111,%11111101,%11111101,%11011111,%11111100,%11111110,%11101111,%11111110,%01111111,%01110111,%11111111,%01011111,%11111111,%11111111,%11111111
  .db %11111011,%11100111,%01111001,%11111101,%11110011,%10111111,%01111110,%11111001,%11011111,%10111111,%01111100,%11101111,%01011111,%11111111,%11111111,%11111111
  .db %11111011,%10101010,%10111101,%11111101,%11010101,%01011110,%11111110,%11101010,%10101111,%01111111,%01110101,%01010111,%00011111,%11111111,%11111111,%11111111
  .db %11111011,%10101010,%01111101,%11111101,%11010101,%00111101,%11111110,%11101010,%10011111,%10111111,%01110101,%01001111,%11011111,%11111111,%11111111,%11111111
  .db %11111000,%10101011,%00111101,%11111100,%01010101,%10011100,%01111110,%00101010,%11001110,%01111111,%00010101,%01100111,%11011111,%11111000,%11111010,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111011,%10101110,%01111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111001,%11011010,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111011,%11011010,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111000,%10101011,%01111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00010000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111

.end
